#ifndef __MEMA_H__
#define __MEMA_H__

#include <stdlib.h>

struct _mema_block
{
    void * data;
    size_t size;

    struct _mema_block * prev, * next;
};

struct _mema_context
{
    struct _mema_block *blocks;

    size_t size;
};

struct _mema_context
_mema_global_context;

#define lmema_init()                                struct _mema_context _mema_local
#define lalloc(size)                                _mema_alloc(&_mema_local, size)
#define lcalloc(nmemb, size)                        _mema_calloc(&_mema_local, nmemb, size)
#define lfree(ptr)                                  _mema_free(&_mema_local, ptr)

void * _mema_free_all(struct _mema_context * context);

void * _mema_alloc(struct _mema_context * context, size_t size);
void * _mema_calloc(struct _mema_context * context, size_t nmemb, size_t size);
void * _mema_free(struct _mema_context * context, void *ptr);

#endif
